from RoboidControl.Thing import Thing
from RoboidControl.Messages import LowLevelMessages

class TemperatureSensor(Thing):
    """! A temperature sensor
    """
    def __init__(self, owner = None, parent = None, thing_id = 0):
        super().__init__(owner = owner, parent = parent, thing_type = Thing.Type.TemperatureSensor, thing_id = thing_id)

        ## The temperature in degrees celcius
        self.temperature = 0
    
    def GenerateBinary(self, bytes, ix_ref):
        """! Function used to generate binary data for this temperature sensor
        @param bytes The byte array for thw binary data
        @param ix_ref A single element array with the starting position for writing the binary data
        @returns The size of the binary data
        """
        LowLevelMessages.SendFloat16(bytes, ix_ref, self.temperature)
        return 2

    def ProcessBinary(self, bytes):
        """! Function used to process the binary data received for this temperature sensor
        @param bytes The binary data to process
        """
        ix = 0
        self.temperature = LowLevelMessages.ReceiveFloat16(bytes, [ix])
