from RoboidControl.Thing import Thing

class TouchSensor(Thing):
    """! A sensor which can detect touches
    """
    def __init__(self, owner = None, parent = None, thing_id = 0):
        """! Create a touch sensor
        """
        super().__init__(owner = owner, parent = parent)
        self.type = Thing.Type.TouchSensor
        ## Value which is true when the sensor is touching something, false otherwise
        self.touched_something = False

    def GenerateBinary(self, bytes, ix_ref):
        """! Function used to generate binary data for this touch sensor
        @param bytes The byte array for thw binary data
        @param ix_ref A single element array with the starting position for writing the binary data
        @returns The size of the binary data
        """
        ix = ix_ref[0]
        if self.touched_something:
            bytes[ix] = 0
        else:
            bytes[ix] = 1
        ix_ref[0] += 1
        return 1
    
    def ProcessBinary(self, bytes):
        """! Function used to process binary data received for this touch sensor
        @param bytes The binary data to process
        """
        self.touched_something = bytes[0] == 1
